import { Class, ParameterPropertyReflection, ClassReflection } from "./types";
declare function useCache<K, P extends any[], R>(cache: Map<K, R>, fn: (...args: P) => R, getKey: (...args: P) => K): (...args: P) => R;
declare namespace metadata {
    function createClass(parent: Class, name: string): Class;
    function isParameterProperties(meta: any): meta is ParameterPropertyReflection;
    function isCallback(type: any): type is ((x: any) => Class[] | Class | string | string[]);
    function isConstructor(value: any): boolean;
    function isCustomClass(type: Function | Function[]): boolean;
    function getMethods(meta: ClassReflection): {
        name: string;
        type: any;
        pars: {
            name: string;
            type: any;
        }[];
    }[];
    function getProperties(meta: ClassReflection): {
        name: string;
        type: any;
    }[];
}
export { useCache, metadata };
